"use client"
import { useIntl } from "react-intl"

import { formatPrice } from "@/utils/numberFormatting"

import BoldRow from "../Bold"
import RegularRow from "../Regular"
import BedTypeRow from "./BedType"
import PackagesRow from "./Packages"

import type { CurrencyEnum } from "@/types/enums/currency"
import type { SharedPriceRowProps } from "./price"

export interface RegularPriceType {
  regular?: {
    currency: CurrencyEnum
    pricePerNight: number
    pricePerStay: number
  }
}

interface RegularPriceProps extends SharedPriceRowProps {
  price: RegularPriceType["regular"]
}

export default function RegularPrice({
  bedType,
  nights,
  packages,
  price,
}: RegularPriceProps) {
  const intl = useIntl()

  if (!price) {
    return null
  }

  const averagePriceTitle = intl.formatMessage({
    defaultMessage: "Average price per night",
  })

  const avgeragePricePerNight = formatPrice(
    intl,
    price.pricePerNight,
    price.currency
  )

  const roomCharge = formatPrice(intl, price.pricePerStay, price.currency)

  return (
    <>
      <BoldRow
        label={intl.formatMessage({ defaultMessage: "Room charge" })}
        value={roomCharge}
      />
      {nights > 1 ? (
        <RegularRow label={averagePriceTitle} value={avgeragePricePerNight} />
      ) : null}
      <BedTypeRow bedType={bedType} currency={price.currency} />
      <PackagesRow packages={packages} />
    </>
  )
}
